=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2009-06-26 06:25:57 +0000
+++ drizzled/Makefile.am	2009-07-01 17:38:47 +0000
@@ -73,7 +73,6 @@
 		foreign_key.h \
 		function/additive_op.h \
 		function/ascii.h \
-		function/benchmark.h \
 		function/char_length.h \
 		function/coercibility.h \
 		function/connection_id.h \
@@ -406,7 +405,6 @@
 		foreign_key.cc \
 		function/ascii.cc \
 		function/additive_op.cc \
-		function/benchmark.cc \
 		function/char_length.cc \
 		function/check_reserved_words.cc \
 		function/connection_id.cc \

=== removed file 'drizzled/function/benchmark.cc'
--- drizzled/function/benchmark.cc	2009-01-28 04:37:46 +0000
+++ drizzled/function/benchmark.cc	1970-01-01 00:00:00 +0000
@@ -1,90 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#include <drizzled/server_includes.h>
-#include CSTDINT_H
-#include <drizzled/function/benchmark.h>
-#include <drizzled/error.h>
-#include <drizzled/session.h>
-
-
-/* This function is just used to test speed of different functions */
-
-int64_t Item_func_benchmark::val_int()
-{
-  assert(fixed == 1);
-  char buff[MAX_FIELD_WIDTH];
-  String tmp(buff,sizeof(buff), &my_charset_bin);
-  my_decimal tmp_decimal;
-  Session *session=current_session;
-  uint64_t loop_count;
-
-  loop_count= (uint64_t) args[0]->val_int();
-
-  if (args[0]->null_value ||
-      (!args[0]->unsigned_flag && (((int64_t) loop_count) < 0)))
-  {
-    if (!args[0]->null_value)
-    {
-      llstr(((int64_t) loop_count), buff);
-      push_warning_printf(current_session, DRIZZLE_ERROR::WARN_LEVEL_ERROR,
-                          ER_WRONG_VALUE_FOR_TYPE, ER(ER_WRONG_VALUE_FOR_TYPE),
-                          "count", buff, "benchmark");
-    }
-
-    null_value= 1;
-    return 0;
-  }
-
-  null_value=0;
-  for (uint64_t loop=0 ; loop < loop_count && !session->killed; loop++)
-  {
-    switch (args[1]->result_type()) {
-    case REAL_RESULT:
-      (void) args[1]->val_real();
-      break;
-    case INT_RESULT:
-      (void) args[1]->val_int();
-      break;
-    case STRING_RESULT:
-      (void) args[1]->val_str(&tmp);
-      break;
-    case DECIMAL_RESULT:
-      (void) args[1]->val_decimal(&tmp_decimal);
-      break;
-    case ROW_RESULT:
-    default:
-      // This case should never be chosen
-      assert(0);
-      return 0;
-    }
-  }
-  return 0;
-}
-
-
-void Item_func_benchmark::print(String *str, enum_query_type query_type)
-{
-  str->append(STRING_WITH_LEN("benchmark("));
-  args[0]->print(str, query_type);
-  str->append(',');
-  args[1]->print(str, query_type);
-  str->append(')');
-}
-

=== removed file 'drizzled/function/benchmark.h'
--- drizzled/function/benchmark.h	2009-05-15 01:47:27 +0000
+++ drizzled/function/benchmark.h	1970-01-01 00:00:00 +0000
@@ -1,38 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#ifndef DRIZZLED_FUNCTION_BENCHMARK_H
-#define DRIZZLED_FUNCTION_BENCHMARK_H
-
-#include <drizzled/function/func.h>
-#include <drizzled/function/math/int.h>
-
-class Item_func_benchmark :public Item_int_func
-{
-public:
-  Item_func_benchmark(Item *count_expr, Item *expr)
-    :Item_int_func(count_expr, expr)
-  {}
-  int64_t val_int();
-  const char *func_name() const { return "benchmark"; }
-  void fix_length_and_dec() { max_length=1; maybe_null=0; }
-  virtual void print(String *str, enum_query_type query_type);
-};
-
-#endif /* DRIZZLED_FUNCTION_BENCHMARK_H */

=== modified file 'drizzled/item/create.cc'
--- drizzled/item/create.cc	2009-05-22 17:13:38 +0000
+++ drizzled/item/create.cc	2009-07-01 17:38:47 +0000
@@ -70,7 +70,7 @@
 #include <drizzled/function/additive_op.h>
 #include <drizzled/function/math/asin.h>
 #include <drizzled/function/math/atan.h>
-#include <drizzled/function/benchmark.h>
+/* #include <drizzled/function/benchmark.h> */
 #include <drizzled/function/math/ceiling.h>
 #include <drizzled/function/char_length.h>
 #include <drizzled/function/coercibility.h>
@@ -323,7 +323,7 @@
   virtual ~Create_func_atan() {}
 };
 
-
+/*
 class Create_func_benchmark : public Create_func_arg2
 {
 public:
@@ -337,7 +337,7 @@
   Create_func_benchmark() {}
   virtual ~Create_func_benchmark() {}
 };
-
+*/
 
 class Create_func_bin : public Create_func_arg1
 {
@@ -1748,7 +1748,7 @@
   return func;
 }
 
-
+/*
 Create_func_benchmark Create_func_benchmark::s_singleton;
 
 Item*
@@ -1756,7 +1756,7 @@
 {
   return new (session->mem_root) Item_func_benchmark(arg1, arg2);
 }
-
+*/
 
 Create_func_bin Create_func_bin::s_singleton;
 
@@ -2829,7 +2829,7 @@
   { { C_STRING_WITH_LEN("ASIN") }, BUILDER(Create_func_asin)},
   { { C_STRING_WITH_LEN("ATAN") }, BUILDER(Create_func_atan)},
   { { C_STRING_WITH_LEN("ATAN2") }, BUILDER(Create_func_atan)},
-  { { C_STRING_WITH_LEN("BENCHMARK") }, BUILDER(Create_func_benchmark)},
+/*  { { C_STRING_WITH_LEN("BENCHMARK") }, BUILDER(Create_func_benchmark)}, */
   { { C_STRING_WITH_LEN("BIN") }, BUILDER(Create_func_bin)},
   { { C_STRING_WITH_LEN("CEIL") }, BUILDER(Create_func_ceiling)},
   { { C_STRING_WITH_LEN("CEILING") }, BUILDER(Create_func_ceiling)},

=== added directory 'plugin/benchmark'
=== added file 'plugin/benchmark/AUTHORS'
--- plugin/benchmark/AUTHORS	1970-01-01 00:00:00 +0000
+++ plugin/benchmark/AUTHORS	2009-07-01 17:38:47 +0000
@@ -0,0 +1,3 @@
+Devananda van der Veen <devananda.vdv@gmail.com>
+
+(Originally from MySQL Benchmark function)

=== added file 'plugin/benchmark/ChangeLog'
--- plugin/benchmark/ChangeLog	1970-01-01 00:00:00 +0000
+++ plugin/benchmark/ChangeLog	2009-07-01 17:38:47 +0000
@@ -0,0 +1,2 @@
+0.1
+  - Added

=== added file 'plugin/benchmark/benchmarkudf.cc'
--- plugin/benchmark/benchmarkudf.cc	1970-01-01 00:00:00 +0000
+++ plugin/benchmark/benchmarkudf.cc	2009-07-01 17:38:47 +0000
@@ -0,0 +1,109 @@
+/* 
+ -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ */
+
+#include <drizzled/server_includes.h>
+#include <drizzled/error.h>
+#include <drizzled/session.h>
+
+using namespace std;
+
+class Item_func_benchmark :public Item_int_func
+{
+public:
+//  Item_func_benchmark(Item *count_expr, Item *expr) :Item_int_func(count_expr, expr)  {}
+  Item_func_benchmark() :Item_int_func() {}
+  int64_t val_int();
+  virtual void print(String *str, enum_query_type query_type);
+
+  const char *func_name() const      { return "benchmark"; }
+  void fix_length_and_dec()          { max_length=1; maybe_null=0; }
+  bool check_argument_count(int n)   { return (n==2); }
+};
+
+
+/* This function is just used to test speed of different functions */
+int64_t Item_func_benchmark::val_int()
+{
+  assert(fixed == 1);
+  char buff[MAX_FIELD_WIDTH];
+  String tmp(buff,sizeof(buff), &my_charset_bin);
+  my_decimal tmp_decimal;
+  Session *session=current_session;
+  uint64_t loop_count;
+
+  loop_count= (uint64_t) args[0]->val_int();
+
+  if (args[0]->null_value ||
+      (!args[0]->unsigned_flag && (((int64_t) loop_count) < 0)))
+  {
+    if (!args[0]->null_value)
+    {
+      llstr(((int64_t) loop_count), buff);
+      push_warning_printf(current_session, DRIZZLE_ERROR::WARN_LEVEL_ERROR,
+                          ER_WRONG_VALUE_FOR_TYPE, ER(ER_WRONG_VALUE_FOR_TYPE),
+                          "count", buff, "benchmark");
+    }
+
+    null_value= 1;
+    return 0;
+  }
+
+  null_value=0;
+  for (uint64_t loop=0 ; loop < loop_count && !session->killed; loop++)
+  {
+    switch (args[1]->result_type()) {
+    case REAL_RESULT:
+      (void) args[1]->val_real();
+      break;
+    case INT_RESULT:
+      (void) args[1]->val_int();
+      break;
+    case STRING_RESULT:
+      (void) args[1]->val_str(&tmp);
+      break;
+    case DECIMAL_RESULT:
+      (void) args[1]->val_decimal(&tmp_decimal);
+      break;
+    case ROW_RESULT:
+    default:
+      // This case should never be chosen
+      assert(0);
+      return 0;
+    }
+  }
+  return 0;
+}
+
+void Item_func_benchmark::print(String *str, enum_query_type query_type)
+{
+  str->append(STRING_WITH_LEN("benchmark("));
+  args[0]->print(str, query_type);
+  str->append(',');
+  args[1]->print(str, query_type);
+  str->append(')');
+}
+
+Create_function<Item_func_benchmark> benchmarkudf(string("benchmark"));
+
+static int initialize(PluginRegistry &registry)
+{
+  registry.add(&benchmarkudf);
+  return 0;
+}
+
+drizzle_declare_plugin(benchmark)
+{
+  "benchmark",
+  "0.1",
+  "Devananda van der Veen",
+  "Measure time for repeated calls to a function.",
+  PLUGIN_LICENSE_GPL,
+  initialize, /* Plugin Init */
+  NULL,   /* Plugin Deinit */
+  NULL,   /* status variables */
+  NULL,   /* system variables */
+  NULL    /* config options */
+}
+drizzle_declare_plugin_end;

=== added file 'plugin/benchmark/plugin.ini'
--- plugin/benchmark/plugin.ini	1970-01-01 00:00:00 +0000
+++ plugin/benchmark/plugin.ini	2009-07-01 17:38:47 +0000
@@ -0,0 +1,6 @@
+[plugin]
+name=benchmark
+title=UDF Plugin for Benchmark 
+description=UDF Plugin for Benchmark
+load_by_default=yes
+sources=benchmarkudf.cc

